#!/bin/bash

pdbdir=$1       # input PDB directory
outdir=$2       # output ContactLib directory

workdir="./bin"
dsspcmd="dssp-2-linux-amd64"


if [ "$outdir" == "" ] ; then
  echo -e "USAGE: $0 IN_PDB_DIR OUT_CONTACTLIB_DIR"
  exit;
fi

if [ -d "/dev/shm" ] ; then
  tmpdir="/dev/shm/contactlib/build.$$"
else
  tmpdir="/tmp/contactlib/build.$$"
fi
rm -rf $tmpdir; mkdir -p $tmpdir

index=0
rm -f $outdir/contactlib-*.local-bin $outdir/contactlib-*.remote-bin
mkdir -p $outdir
for pdbfn in `find $pdbdir -name "*.ent"` ; do
  pdbid=`basename ${pdbfn%.*}`
  ofprefix="$tmpdir/$pdbid"

  cmd="$dsspcmd $pdbfn"
  echo -e "#calling <$cmd> ..."
  $cmd >$ofprefix.dssp 2>&1

  cmd="$workdir/contactlib.build $pdbid $pdbfn $ofprefix.dssp 9 3 4 $ofprefix"
  echo -e "#calling <$cmd> ..."
  $cmd >$ofp.log 2>&1

  cat $ofprefix.local-bin >>$outdir/contactlib-$index.local-bin
  cat $ofprefix.remote-bin >>$outdir/contactlib-$index.remote-bin
  size=`du -m $outdir/contactlib-$index.remote-bin | perl -pe "s/\s+.*$//"`
  if [ $size -ge 64 ] ; then
    let index++
  fi
  rm -rf $ofprefix.*
done

rm -rf $tmpdir
echo -e "done!!!"

